Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/declare_ref_func.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/declare_ref_func.hpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/declare_ref_func.hpp	(revision 1984)
@@ -51,6 +51,4 @@
     SuperClassAttribute::setAttributes(refer_ptr, apply);              \
   }                                                                    \
-  if (this->hasAttribute("name") && this->name.isEmpty())              \
-    this->name.setValue(this->get##type##OutputName());                \
 }                                                                      \
                                                                        \
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/gatherer_connector.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/gatherer_connector.hpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/gatherer_connector.hpp	(revision 1984)
@@ -29,11 +29,13 @@
       
       template<typename T>
-      void transfer(int sizeT, map<int, CArray<T,1>>& dataIn, CArray<T,1>& dataOut)
+      void transfer(int repeat, int sizeT, map<int, CArray<T,1>>& dataIn, CArray<T,1>& dataOut)
       {
         // for future, make a specific transfer function for sizeT=1 to avoid multiplication (increasing performance)
-        dataOut.resize(dstSize_*sizeT) ;  
-        T* output = dataOut.dataFirst() ;
+        size_t dstSlice = dstSize_*sizeT ;
+        dataOut.resize(repeat* dstSlice) ;  
+        
         for(auto& data : dataIn)
         {
+          T* output = dataOut.dataFirst() ;
           int rank=data.first ;
           auto input  = data.second.dataFirst() ;
@@ -41,16 +43,27 @@
           auto& mask=mask_[rank] ;
           int size=mask.size() ;
-
-          for(int i=0, j=0 ;i<size;i++)
-          {
-            if (mask[i]) 
+          size_t srcSlice = size * sizeT ;
+          for(int l=0; l<repeat; l++)
+          {   
+            for(int i=0, j=0 ;i<size;i++)
             {
-              int cj = connector[j]*sizeT ;
-              int ci = i*sizeT ;
-              for (int k=0;k<sizeT;k++) output[cj+k] = input[ci+k] ;
-              j++ ;
+              if (mask[i]) 
+              {
+                int cj = connector[j]*sizeT ;
+                int ci = i*sizeT ;
+                for (int k=0;k<sizeT;k++) output[cj+k] = input[ci+k] ;
+                j++ ;
+              }
             }
+            input+=srcSlice ;
+            output+=dstSlice ;
           }
         }
+      }
+
+      template<typename T>
+      void transfer(int sizeT, map<int, CArray<T,1>>& dataIn, CArray<T,1>& dataOut)
+      {
+        transfer(1, 1, dataIn, dataOut) ;
       }
     
@@ -101,5 +114,5 @@
       void transfer(map<int, CArray<T,1>>& dataIn, CArray<T,1>& dataOut, T missingValue)
       {
-        transfer(1, dataIn, dataout, missingValue)
+        transfer(1, 1, dataIn, dataout, missingValue)
       }
       
@@ -107,7 +120,13 @@
       void transfer(int sizeT, map<int, CArray<T,1>>& dataIn, CArray<T,1>& dataOut, T missingValue)
       {
-        dataOut.resize(dstSize_*sizeT) ;
+         transfer(1, sizeT, dataIn, dataOut, missingValue) ;
+      }
+
+      template<typename T>
+      void transfer(int repeat , int sizeT, map<int, CArray<T,1>>& dataIn, CArray<T,1>& dataOut, T missingValue)
+      {
+        dataOut.resize(repeat*dstSize_*sizeT) ;
         dataOut=missingValue ;
-        transfer(sizeT, dataIn, dataOut) ;
+        transfer(1, sizeT, dataIn, dataOut) ;
       }
 
@@ -121,5 +140,5 @@
           (*subEvent.buffer) >> data ;
         }
-        transfer(sizeT, dataIn, dataOut) ;
+        transfer(1, sizeT, dataIn, dataOut) ;
       }
       
@@ -139,5 +158,5 @@
           (*subEvent.buffer) >> data ;
         }
-        transfer(sizeT, dataIn, dataOut, missingValue) ;
+        transfer(1, sizeT, dataIn, dataOut, missingValue) ;
       }
 
@@ -151,5 +170,5 @@
           (*subEvent.buffer) >> data ;
         }
-        transfer(1, dataIn, dataOut, missingValue) ;
+        transfer(1, 1, dataIn, dataOut, missingValue) ;
       }
 
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/grid_remote_connector.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/grid_remote_connector.cpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/grid_remote_connector.cpp	(revision 1984)
@@ -87,6 +87,14 @@
     srcView_[nSrc-1]->getGlobalIndex(srcGlobalIndex, sliceIndex, srcSliceSize.data(), srcView_.data(), nSrc-1) ;
     
-    CArray<size_t,1> srcGlobalIndexArray(srcGlobalIndex.data(), shape(srcGlobalIndex.size()),neverDeleteData) ;
-    dataRanks.computeIndexInfoMapping(srcGlobalIndexArray) ;
+    if (srcGlobalIndex.size()>0)
+    {
+      CArray<size_t,1> srcGlobalIndexArray(srcGlobalIndex.data(), shape(srcGlobalIndex.size()),neverDeleteData) ;
+      dataRanks.computeIndexInfoMapping(srcGlobalIndexArray) ;
+    }
+    else
+    {
+      CArray<size_t,1> srcGlobalIndexArray ;
+      dataRanks.computeIndexInfoMapping(srcGlobalIndexArray) ;
+    }
     const auto& returnInfo = dataRanks.getInfoIndexMap() ;
 
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/scatterer_connector.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/scatterer_connector.hpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/scatterer_connector.hpp	(revision 1984)
@@ -38,5 +38,5 @@
     void transfer(const CArray<T,n>& dataIn, map<int, CArray<T,1>>& dataOut)
     {
-      transfer(1, dataIn, dataOut) ;
+      transfer(1,1, dataIn, dataOut) ;
     }
 
@@ -44,5 +44,5 @@
     void transfer(const CArray<T,n>& dataIn, map<int, CArray<T,1>>& dataOut, T missingValue)
     {
-      transfer(1, dataIn, dataOut, missingValue) ;
+      transfer(1, 1, dataIn, dataOut, missingValue) ;
     }
 
@@ -50,5 +50,12 @@
     void transfer(int sizeT, const CArray<T,n>& dataIn, map<int, CArray<T,1>>& dataOut)
     {
+      transfer(1, sizeT, dataIn, dataOut)
+    }
+    
+    template<typename T, int n>
+    void transfer(int repeat, int sizeT, const CArray<T,n>& dataIn, map<int, CArray<T,1>>& dataOut)
+    {
       // for future, make a specific transfer function for sizeT=1 to avoid multiplication (increasing performance)
+      size_t srcSlice = sizeT*srcSize_ ;
       for(auto& rankConnector : connector_)
       {
@@ -58,20 +65,27 @@
         int dstSize = mask.size() ;
         auto& data = dataOut[rank] ;
-        data.resize(dstSize * sizeT) ;
+        size_t dstSlice = dstSize*sizeT ;
+        data.resize(repeat*dstSlice) ;
         T* dstData = data.dataFirst() ;
         const T* srcData = dataIn.dataFirst() ;
-        for(int i=0, j=0; i<dstSize; i++)
-          if (mask[i]) 
-          {
-            for(int k=0;k<sizeT;k++) dstData[i*sizeT+k] = srcData[connector[j]*sizeT+k] ;
-            j++ ;
-          }
-      }
-    }
-
-    template<typename T, int n>
-    void transfer(int sizeT, const CArray<T,n>& dataIn, map<int, CArray<T,1>>& dataOut, T missingValue)
+        for(int l=0; l<repeat; l++)
+        {
+          for(int i=0, j=0; i<dstSize; i++)
+            if (mask[i]) 
+            {
+              for(int k=0;k<sizeT;k++) dstData[i*sizeT+k] = srcData[connector[j]*sizeT+k] ;
+              j++ ;
+            }
+          dstData+=dstSlice ;
+          srcData+=srcSlice ;
+        }
+      }
+    }
+
+    template<typename T, int n>
+    void transfer(int repeat, int sizeT, const CArray<T,n>& dataIn, map<int, CArray<T,1>>& dataOut, T missingValue)
     {
       // for future, make a specific transfer function for sizeT=1 to avoid multiplication (increasing performance)
+      size_t srcSlice = sizeT*srcSize_ ;
       for(auto& rankConnector : connector_)
       {
@@ -81,18 +95,24 @@
         int dstSize = mask.size() ;
         auto& data = dataOut[rank] ;
-        data.resize(dstSize * sizeT) ;
+        size_t dstSlice = dstSize*sizeT ;
+        data.resize(repeat * dstSlice) ;
         T* dstData = data.dataFirst() ;
         const T* srcData = dataIn.dataFirst() ;
-        for(int i=0, j=0; i<dstSize; i++)
-          if (mask[i]) 
-          {
-            for(int k=0;k<sizeT;k++) dstData[i*sizeT+k] = srcData[connector[j]*sizeT+k] ;
-            j++ ;
-          }
-          else 
-          {
-            for(int k=0;k<sizeT;k++) dstData[i*sizeT+k] = missingValue ;
-            j++ ;
-          }
+        for(int l=0; l<repeat; l++)
+        {
+          for(int i=0, j=0; i<dstSize; i++)
+            if (mask[i]) 
+            {
+              for(int k=0;k<sizeT;k++) dstData[i*sizeT+k] = srcData[connector[j]*sizeT+k] ;
+              j++ ;
+            }
+            else 
+            {
+              for(int k=0;k<sizeT;k++) dstData[i*sizeT+k] = missingValue ;
+              j++ ;
+            }
+          dstData+=dstSlice ;
+          srcData+=srcSlice ;
+        }
       }
     }
@@ -101,5 +121,5 @@
     void transfer(const CArray<T,n>& dataIn, CContextClient* client, CEventClient& event, const CMessage& messageHeader)
     {
-      transfer(1, dataIn, client, event, messageHeader) ;
+      transfer( 1, dataIn, client, event, messageHeader) ;
     }
 
@@ -107,5 +127,5 @@
     void transfer(const CArray<T,n>& dataIn, T missingValue, CContextClient* client, CEventClient& event, const CMessage& messageHeader)
     {
-      transfer(1, dataIn, missingValue, client, event, messageHeader) ;
+      transfer( 1, dataIn, missingValue, client, event, messageHeader) ;
     }
 
@@ -114,5 +134,5 @@
     {
       map<int, CArray<T,1>> dataOut ;
-      transfer(sizeT, dataIn, dataOut) ;
+      transfer(1, sizeT, dataIn, dataOut) ;
       sendToServer(dataOut, client, event, messageHeader) ;
     }
@@ -122,5 +142,5 @@
     {
       map<int, CArray<T,1>> dataOut ;
-      transfer(sizeT, dataIn, dataOut, missingValue) ;
+      transfer(1, sizeT, dataIn, dataOut, missingValue) ;
       sendToServer(dataOut, client, event, messageHeader) ;
     }
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/transform_connector.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/transform_connector.cpp	(revision 1984)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/transform_connector.cpp	(revision 1984)
@@ -0,0 +1,106 @@
+#include "transform_connector.hpp"
+#include "element.hpp"
+#include "scatterer_connector.hpp"
+#include "gatherer_connector.hpp"
+#include "client_client_dht_template.hpp"
+
+
+namespace xios
+{
+  void CTransformConnector::computeConnector(void)
+  {
+     CClientClientDHTTemplate<int>::Index2VectorInfoTypeMap info ;
+     
+     // first, insert destination global index into DHT
+     int rank ;
+     MPI_Comm_rank(localComm_, &rank) ;
+     CArray<size_t,1> globalIndex ;
+     dstView_->getGlobalIndexView(globalIndex) ;
+     for(int i=0;i<globalIndex.numElements();i++) info[globalIndex(i)].push_back(rank) ;  
+     CClientClientDHTTemplate<int> dataRanks(info, localComm_) ;
+
+    // get global src index from src view.
+    set<size_t> setGlobalIndex ; // all global index from src
+    srcView_->getGlobalIndexView(globalIndex) ;
+    for(int i=0;i<globalIndex.numElements();i++) setGlobalIndex.insert(globalIndex((i))) ;
+    
+    CArray<size_t,1> srcGlobalIndex(setGlobalIndex.size()) ;
+    int i=0 ;
+    for(auto& globalIndex : setGlobalIndex) 
+    {
+      srcGlobalIndex(i) = globalIndex ;
+      i++ ;
+    }
+   
+    dataRanks.computeIndexInfoMapping(srcGlobalIndex) ;
+    const auto& returnInfo = dataRanks.getInfoIndexMap() ;
+
+    map<int,vector<size_t>> vectorIndex ;
+    for(auto& rankIndGlo : returnInfo)
+    {
+      size_t indGlo = rankIndGlo.first ;
+      auto& listRank = rankIndGlo.second ;
+      for (auto& rank : listRank)  vectorIndex[rank].push_back(indGlo);
+    }
+
+    // convert vectorIndex into array    
+    map<int,CArray<size_t,1>> dstArrayIndex ;
+    for(auto& rankIndGlo : vectorIndex)
+    {
+      int rank = rankIndGlo.first ;
+      auto& indexVector = rankIndGlo.second ;
+      auto& arrayIndex = dstArrayIndex[rank] ;
+      CArray<size_t,1> arrayTmp(indexVector.data(), shape(indexVector.size()), duplicateData) ;
+      dstArrayIndex[rank].reference(arrayTmp) ;
+    }
+
+    // distributed element : where to send data
+    CDistributedElement dstElement(srcView_->getGlobalSize(), dstArrayIndex) ;
+    dstElement.addFullView() ;
+    
+    // create scatterer connector
+    int commSize ;
+    MPI_Comm_size(localComm_, &commSize) ;
+    scattererConnector_ = new CScattererConnector(srcView_, dstElement.getView(CElementView::FULL), localComm_, commSize ) ;
+    scattererConnector_->computeConnector() ;
+
+    // how much sender ?
+    vector<int> nbSenders(commSize) ;
+    int nbSender ;
+    for(auto& it : dstArrayIndex) nbSenders[it.first]=1 ;
+    vector<int> recvCounts(commSize,1) ;
+    MPI_Reduce_scatter(nbSenders.data(), &nbSender, recvCounts.data(), MPI_INT, MPI_SUM, localComm_) ;
+    
+    // transfer global index
+    map<int,CArray<size_t,1>> remoteArrayIndex ;
+    
+    vector<MPI_Request> sendReq ;
+    for(auto& it : dstArrayIndex)
+    {
+      MPI_Request req ;
+      MPI_Isend(it.second.dataFirst(), it.second.numElements(), MPI_SIZE_T, it.first,0, localComm_,&req) ;
+      sendReq.push_back(req) ;
+    }
+
+    for(int i=0; i<nbSender; i++) 
+    {
+      int size ;
+      MPI_Status status ;
+      MPI_Probe(MPI_ANY_SOURCE, 0, localComm_, &status ) ;
+      MPI_Get_count(&status, MPI_SIZE_T, &size) ;
+      vector<size_t> recvBuff(size) ;
+      MPI_Recv(recvBuff.data(), size, MPI_SIZE_T, status.MPI_SOURCE,0,localComm_,&status) ;
+      CArray<size_t,1> arrayTmp(recvBuff.data(), shape(recvBuff.size()), duplicateData) ;
+      remoteArrayIndex[status.MPI_SOURCE].reference(arrayTmp) ;
+      recvRankSize_[status.MPI_SOURCE] = size ;
+    }
+    vector<MPI_Status> sendStatus(sendReq.size()) ;
+    MPI_Waitall(sendReq.size(),sendReq.data(),sendStatus.data()) ;
+
+    CDistributedElement remoteElement(dstView_->getGlobalSize(), remoteArrayIndex) ;
+    remoteElement.addFullView() ;
+    gathererConnector_=new CGathererConnector(remoteElement.getView(CElementView::FULL),dstView_) ;
+    gathererConnector_->computeConnector() ;
+
+  }
+}
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/transform_connector.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/transform_connector.hpp	(revision 1984)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/transform_connector.hpp	(revision 1984)
@@ -0,0 +1,80 @@
+#ifndef __TRANSFORM_CONNECTOR_HPP__
+#define __TRANSFORM_CONNECTOR_HPP__
+
+#include "xios_spl.hpp"
+#include "array_new.hpp"
+#include "distributed_view.hpp"
+#include "local_view.hpp"
+#include "scatterer_connector.hpp"
+#include "gatherer_connector.hpp"
+#include "mpi.hpp"
+
+namespace xios
+{
+ 
+  
+  class CTransformConnector
+  {
+     
+    public:
+      CTransformConnector(CLocalView* srcView, CLocalView* dstView, MPI_Comm localComm) 
+                          : srcView_(srcView), dstView_(dstView), localComm_(localComm) {}
+    
+      void computeConnector(void) ; 
+    private:
+
+      MPI_Comm localComm_ ;
+      CLocalView* srcView_ ;
+      CLocalView* dstView_ ;
+      map<int,int> recvRankSize_ ;
+      CScattererConnector* scattererConnector_=nullptr ;
+      CGathererConnector*  gathererConnector_=nullptr ;
+   
+    public:
+      template<typename T> 
+      void transfer(int repeat, int sizeT, const CArray<T,1>& dataIn, CArray<T,1>& dataOut)
+      {
+        map<int,CArray<T,1>> tmpArrayIn ;
+        scattererConnector_->transfer(repeat, sizeT, dataIn, tmpArrayIn) ;
+        vector<MPI_Request> requests ;
+        MPI_Request request ;
+        for(auto it : tmpArrayIn)
+        {
+          auto& array = it.second ; 
+          MPI_Issend(array.dataFirst(), array.numElements(), MPI_GetType<T>(), it.first, 0, localComm_, &request) ;
+          requests.push_back(request) ;
+        }
+        
+        map<int,CArray<T,1>> tmpArrayOut ;
+        for(auto it : recvRankSize_)
+        {
+          auto& array = tmpArrayOut[it.first] ;
+          array.resize(it.second*repeat*sizeT) ;
+          MPI_Irecv(array.dataFirst(), array.numElements(), MPI_GetType<T>(), it.first, 0, localComm_, &request) ;
+          requests.push_back(request) ;
+        }
+        
+        vector<MPI_Status> status(requests.size()) ;
+        MPI_Waitall(requests.size(), requests.data(),status.data()) ;
+        
+        const double nanValue = std::numeric_limits<double>::quiet_NaN();
+        gathererConnector_->transfer(repeat, sizeT , tmpArrayOut, dataOut, nanValue) ;
+      }
+
+      template<typename T> 
+      void transfer(int sizeT, const CArray<T,1>& dataIn, CArray<T,1>& dataOut)
+      {
+        transfer(1, sizeT, dataIn, dataOut) ;
+      }
+   
+      template<typename T> 
+      void transfer(const CArray<T,1>& dataIn, CArray<T,1>& dataOut)
+      {
+        transfer(1, 1, dataIn, dataOut) ;
+      }
+
+  };
+
+}
+
+#endif
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/weight_transform_connector.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/weight_transform_connector.cpp	(revision 1984)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/weight_transform_connector.cpp	(revision 1984)
@@ -0,0 +1,41 @@
+#include "weight_transform_connector.hpp"
+
+namespace xios
+{
+
+  CWeightTransformConnector::CWeightTransformConnector(CLocalView* srcView, CLocalView* dstView, unordered_map<int, std::vector<int>>& indexMap, 
+                                                   unordered_map<int, std::vector<double>>& weightMap) : srcView_(srcView), dstView_(dstView)
+  {
+    computeConnector(indexMap, weightMap) ;
+  }
+
+  void CWeightTransformConnector::computeConnector(unordered_map<int, std::vector<int>>& indexMap, 
+                                                   unordered_map<int, std::vector<double>>& weightMap)
+  {
+    CArray<size_t,1> dstGlobalIndex ;
+    CArray<size_t,1> srcGlobalIndex ;
+    dstView_->getGlobalIndexView(dstGlobalIndex) ;
+    srcView_->getGlobalIndexView(srcGlobalIndex) ;
+    unordered_map<size_t,int> srcMapIndex ;
+    srcSize_ = srcGlobalIndex.numElements() ;
+    dstSize_ = dstGlobalIndex.numElements() ;
+
+    for(int i=0;i<srcSize_;i++) srcMapIndex[srcGlobalIndex(i)]=i ;
+    for(int i=0; i< dstSize_;i++) 
+    {
+      if (indexMap.count(dstGlobalIndex(i))!=0 && weightMap.count(dstGlobalIndex(i))!=0)
+      {
+        auto& vectIndex  = indexMap[dstGlobalIndex(i)] ;
+        auto& vectWeight = weightMap[dstGlobalIndex(i)] ;
+        nWeights_.push_back(vectIndex.size()) ;
+        for(int j=0; j<vectIndex.size();j++)
+        {
+          connector_.push_back(srcMapIndex[vectIndex[j]]) ;
+          weights_.push_back(vectWeight[j]) ;
+        }
+      }
+      else nWeights_.push_back(0) ;
+    }
+  }
+
+}
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/weight_transform_connector.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/weight_transform_connector.hpp	(revision 1984)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/weight_transform_connector.hpp	(revision 1984)
@@ -0,0 +1,69 @@
+#ifndef __WEIGHT_TRANSFORM_CONNECTOR_HPP__
+#define __WEIGHT_TRANSFORM_CONNECTOR_HPP__
+
+#include "xios_spl.hpp"
+#include "array_new.hpp"
+#include "local_view.hpp"
+
+
+
+namespace xios
+{
+  
+  class CWeightTransformConnector
+  {
+    
+    private:
+      CLocalView* srcView_;
+      CLocalView* dstView_;
+
+      vector<double> weights_; //  sizeof sum(nWeights_)  
+      vector<int> connector_;  //  sizeof sum(nWeights_)  
+      vector<int> nWeights_ ;  //  sizeof dstSize_ 
+      int srcSize_ ;
+      int dstSize_ ;
+
+     void computeConnector(unordered_map<int, std::vector<int>>& indexMap, unordered_map<int, std::vector<double>>& weightMap) ;
+      
+    public:
+
+    CWeightTransformConnector(CLocalView* srcView, CLocalView* dstView, unordered_map<int, std::vector<int>>& indexMap, 
+                              unordered_map<int, std::vector<double>>& weightMap) ;
+ 
+    void transfer(int repeat, int sizeT, const CArray<double,1>& dataIn, CArray<double,1>& dataOut)
+    {
+      int dstSlice = dstSize_*sizeT ;
+      int srcSlice = srcSize_*sizeT ;
+      dataOut.resize(repeat* dstSlice) ;
+      dataOut=0 ; // what to do about missing value => next step ?
+
+      const double* input = dataIn.dataFirst()  ;
+      double* output = dataOut.dataFirst()  ;
+
+      for(int r=0;r<repeat;r++, input+=srcSlice, output+=dstSlice)
+      {
+        const double* in = input;
+        double* out = output ;
+        int k=0 ;
+        for(int i=0; i<dstSize_; i++, out+=sizeT)
+          for(int j=0 ; j<nWeights_[i] ; j++,k++)
+            for(int l=0; l<sizeT; l++) out[l] += in[connector_[k]*sizeT+l]*weights_[k] ;
+      }
+    }
+
+    void transfer(int sizeT, const CArray<double,1>& dataIn, CArray<double,1>& dataOut)
+    { 
+      transfer(1,sizeT, dataIn, dataOut) ;
+    }
+    
+    void transfer(const CArray<double,1>& dataIn, CArray<double,1>& dataOut)
+    {
+      transfer(1,1,dataIn, dataOut) ;
+    }
+
+  
+  };
+
+}
+
+#endif
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/client_to_server_store_filter.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/client_to_server_store_filter.cpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/client_to_server_store_filter.cpp	(revision 1984)
@@ -25,5 +25,5 @@
     CMessage message ;
     message<<field_->getId() << data[0]->timestamp ;
-    field_->getGrid()->getClientToServerConnector(client_)->transfer(data[0]->data, client_, event, message) ;
+    field_->getSentGrid()->getClientToServerConnector(client_)->transfer(data[0]->data, client_, event, message) ;
     CTimer::get("Field : send data").suspend();
   }
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/transform_filter.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/transform_filter.cpp	(revision 1984)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/transform_filter.cpp	(revision 1984)
@@ -0,0 +1,28 @@
+#include "transform_filter.hpp"
+
+namespace xios
+{
+  
+  CTransformFilter::CTransformFilter( CGarbageCollector& gc, CGenericAlgorithmTransformation* algo, int dimBefore, int dimAfter, 
+                                      bool detectMissingValues, double defaultValue) 
+                                    : CFilter(gc, 1, this), algorithm_(algo), dimBefore_(dimBefore), dimAfter_(dimAfter), 
+                                      detectMissingValues_(detectMissingValues), defaultValue_(defaultValue)
+  {
+
+  }
+
+  CDataPacketPtr CTransformFilter::apply(std::vector<CDataPacketPtr> data)
+  {
+    // for now, no auxilliairy field
+    CDataPacketPtr packet(new CDataPacket);
+    packet->date = data[0]->date;
+    packet->timestamp = data[0]->timestamp;
+    packet->status = data[0]->status;
+
+    if (packet->status == CDataPacket::NO_ERROR) algorithm_->apply(dimBefore_, dimAfter_, data[0]->data, packet->data);
+    return packet;
+  }
+
+
+
+}
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/transform_filter.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/transform_filter.hpp	(revision 1984)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/transform_filter.hpp	(revision 1984)
@@ -0,0 +1,40 @@
+#ifndef __XIOS_TRANSFORM_FILTER_HPP__
+#define __XIOS_TRANSFORM_FILTER_HPP__
+
+#include "filter.hpp"
+#include "generic_algorithm_transformation.hpp"
+
+namespace xios
+{
+  
+  /*!
+   * A generic filter with multiple input slots wrapping any type of spatial transformations.
+   */
+  class CTransformFilter : public CFilter, IFilterEngine
+  {
+    public:
+
+      CTransformFilter(CGarbageCollector& gc, CGenericAlgorithmTransformation* algo, int dimBefore, int dimAfter, 
+                              bool detectMissingValues, double defaultValue) ;
+
+    protected:
+      /*!
+        Overriding this function to process transformations with auxillary inputs
+      */
+      CDataPacketPtr virtual apply(std::vector<CDataPacketPtr> data) ;
+      void apply(const CArray<double, 1>& dataSrc, CArray<double,1>& dataDest);
+
+    private :
+     
+     CGenericAlgorithmTransformation* algorithm_ ;
+     int dimBefore_ ;
+     int dimAfter_ ;
+     bool detectMissingValues_ ;
+     bool defaultValue_ ;
+
+  }; // class CTransformFilter
+
+
+} // namespace xios
+
+#endif //__XIOS_CSpatialTransformFilter__
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/mpi_tools.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/mpi_tools.hpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/mpi_tools.hpp	(revision 1984)
@@ -1,3 +1,4 @@
 #ifndef __XIOS_MPI_TOOLS_HPP__
+#define __XIOS_MPI_TOOLS_HPP__
 
 #include <string>
@@ -7,4 +8,30 @@
 
   int MPI_Bcast_string(std::string& str, int root, MPI_Comm comm) ;
+
+  template<typename T> 
+  MPI_Datatype MPI_GetType(void) ;
+
+  template<>
+  MPI_Datatype MPI_GetType<char>(void) { return MPI_CHAR ;}
+
+  template<>
+  MPI_Datatype MPI_GetType<short int>(void) { return MPI_SHORT ;}
+
+  template<>
+  MPI_Datatype MPI_GetType<int>(void) { return MPI_INT ;}
+
+  template<>
+  MPI_Datatype MPI_GetType<size_t>(void) { return MPI_SIZE_T ;}
+
+  template<>
+  MPI_Datatype MPI_GetType<float>(void) { return MPI_FLOAT ;}
+
+  template<>
+  MPI_Datatype MPI_GetType<double>(void) { return MPI_DOUBLE ;}
+
+  template<>
+  MPI_Datatype MPI_GetType<long double>(void) { return MPI_LONG_DOUBLE ;}
+
+
 } 
 #endif
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.cpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.cpp	(revision 1984)
@@ -555,5 +555,5 @@
    * Go through the hierarchy to find the axis from which the transformations must be inherited
    */
-  void CAxis::solveInheritanceTransformation()
+  void CAxis::solveInheritanceTransformation_old()
   TRY
   {
@@ -572,4 +572,41 @@
       for (size_t i = 0; i < refAxis.size(); ++i)
         refAxis[i]->setTransformations(axis->getAllTransformations());
+  }
+  CATCH_DUMP_ATTR
+
+  void CAxis::solveInheritanceTransformation()
+  TRY
+  {
+    if (solveInheritanceTransformation_done_) return;
+    else solveInheritanceTransformation_done_=true ;
+
+    CAxis* axis = this;
+    std::list<CAxis*> refAxis;
+    bool out=false ;
+    vector<StdString> excludedAttr;
+    excludedAttr.push_back("axis_ref");
+    
+    refAxis.push_front(axis) ;
+    while (axis->hasDirectAxisReference() && !out)
+    {
+      CAxis* lastAxis=axis ;
+      axis = axis->getDirectAxisReference();
+      axis->solveRefInheritance() ;
+      if (!axis->SuperClass::isEqual(lastAxis,excludedAttr)) out=true ;
+      refAxis.push_front(axis) ;
+    }
+
+    CTransformationPaths::TPath path ;
+    auto& pathList = std::get<2>(path) ;
+    std::get<0>(path) = EElement::AXIS ;
+    std::get<1>(path) = refAxis.front()->getId() ;
+    for (auto& axis : refAxis)
+    {
+      CAxis::TransMapTypes transformations = axis->getAllTransformations();
+      for(auto& transformation : transformations) pathList.push_back({transformation.second->getTransformationType(), 
+                                                                      transformation.second->getId()}) ;
+    }
+    transformationPaths_.addPath(path) ;
+
   }
   CATCH_DUMP_ATTR
